/*
CD Audio class
written by Gary White
Published in the dbase.watercooler newsgroup Wed, 09 May 2001

Modified by Jean-Pierre Martel on October 2002
*/
class cdAudio

   Function init
      if type('mciSendString') # 'FP'
         extern clong mciSendString(cString,cString,cLong,cLong);
            "winmm.dll" from "mciSendStringA"
      endif
      if type('mciGetErrorString') # 'FP'
         extern clong mciGetErrorString(cLong,cString,cLong);
            "winmm.dll" from "mciGetErrorStringA"
      endif
      this.tracks = new array()
      this.open = false
      // four new properties added to create loops (JPM)
      this.loopStartTime  = 0
      this.loopEndTime    = 80000000
*      this.open = (this.sendCommand('open cdaudio') == '1')
      // next line to prevent two instances of the CD Audio class to be loaded
      this.open = (this.sendCommand('open cdaudio shareable') == "1")  // JPM
      if this.open
         this.sendCommand('set cdaudio time format tmsf')
      endif
      return this.open

   Function SendCommand(cCmd)
      try
         cRet = space(256)
         nRet = mciSendString(cCmd, cRet, len(cRet), 0)
         if nRet # 0
            cRet = space(256)
            mciGetErrorString(nRet, cRet, len(cRet))
            cRet = trim(cRet)
            cRet = left(cRet, len(cRet) - 1)
            msgbox(cRet, 'Error', 16)
         endif
      catch (exception e)
         msgbox(e.message, 'Error', 16)
      endtry
      cRet = trim(cRet)
      if len(cRet) > 0
         cRet = left(cRet, len(cRet) -1)
      endif
      return trim( cRet )

   Function CurrentTrack
      local cPos
      cPos = ''
      if this.open and this.mode() # 'open'
         cPos = this.sendCommand('status cdaudio position')
         cPos = left(cPos, 2)
      endif
      return cPos

   Function PositionInTrack
      local cPos
      cPos = ''
      if this.open and this.mode() # 'open'
         cPos = this.sendCommand('status cdaudio position')
         if len(cPos) > 9
            cPos = substr(cPos, 4, 5)
         endif
      endif
      return cPos

   Function Play( nTrack )
      local answer1
      if this.open and this.mode() # 'open'
         if argCount() > 0
            this.sendCommand('play cdaudio from '+nTrack)
         else
            this.sendCommand('play cdaudio')
         endif
      endif
      return

   Function Pause
      if this.open and this.mode() # 'open'
         this.sendCommand('pause cdaudio')
      endif
      return

   Function Stop
      local cTrack
      if this.open and this.mode() # 'open'
         this.sendCommand('stop cdaudio')
         this.sendCommand('seek cdaudio to '+this.currentTrack())
      endif
      return

   Function Mode
      return this.sendCommand('status cdaudio mode')

   Function TrackLength( nTrack )
      local cLen
      if argCount() < 1
         nTrack = val(this.currentTrack())
      endif
      cLen = ''
      if this.open and this.mode() # 'open'
         cLen = this.sendCommand('status cdaudio length track ' + nTrack)
      endif
      if len(cLen) > 5
         cLen := left(cLen, 5)
      endif
      return cLen

   Function DiskTime
      local cTotalTime
      cTotalTime = '00:00'
      if this.open and this.mode() # 'open'
         cTotalTime = left(this.sendCommand('status cdaudio length'),5)
      endif
      return cTotalTime

   Function TotalTracks
      local cRet
      cRet = ''
      if this.open and this.mode() # 'open'
         cRet := this.sendCommand('status cdaudio number of tracks')
      endif
      return cRet

   Function Jump(nTrack)
      local cMode
      if this.open and this.mode() # 'open'
         cMode = this.mode()
         if cMode # 'playing'
            this.sendCommand('seek cdaudio to ' + nTrack + ':00')
         else
            this.play(nTrack +':0')
         endif
      endif
      return

   Function Release
      if this.open
         if this.mode() == 'playing'
            this.stop()
         endif
         this.sendCommand('close cdaudio')
      endif
      release object this
      return

   Function Eject
      if this.open // and this.mode() # 'open'
         if this.sendCommand('capability cdaudio can eject') == 'true'
            this.sendCommand('set cdaudio door open')
         endif
      endif
      return

   Function Close_Door  // JPM
      if this.open // and this.mode() # 'open'
         if this.sendCommand('capability cdaudio can eject') == 'true'
            this.sendCommand('set cdaudio door closed')
         endif
      endif
      return

   Function IsDiskInserted  // returns a tring ("true" or "false")  -- JPM
      return this.sendCommand('status cdaudio media present')

   Function Fast_Forward  // JPM
      local nPosition, nLimit 
      this.sendCommand('set cdaudio time format milliseconds')  // from the onset of the disk
      nLimit = val(this.sendCommand('status cdaudio length'))
      nPosition = val(this.positionInTrack())
      nPosition = nPosition + 5000
      if this.mode() == 'playing'
         if nPosition < nLimit
            this.sendCommand('play cdaudio from ' + nPosition)
         else
            this.sendCommand('play cdaudio from 5000')
         endif
      endif
      this.sendCommand('set cdaudio time format tmsf')
      return

   Function Fast_Rewind(CD_Type)  // JPM
      local nPosition, nLimit
      this.sendCommand('set cdaudio time format milliseconds')  // from the onset of the disk
      nPosition = val(this.positionInTrack())
      nLimit = val(this.sendCommand('status cdaudio length'))
      // "Enhanced" CD and a few regular CD stop about 2 sec sooner than calculated
      nLimit -= 2500
      if this.mode() == 'playing'
         nPosition = nPosition - 5000
         if nPosition > 7000
            this.sendCommand('play cdaudio from ' + nPosition)
         else
            this.sendCommand('play cdaudio from ' + nLimit)
         endif
      endif
      this.sendCommand('set cdaudio time format tmsf')
      return

   Function SetTimeMilliseconds  // JPM
      this.sendCommand('set cdaudio time format milliseconds')  // from the onset of the disk
      return

   Function SetTimeMinSec  // JPM
      this.sendCommand('set cdaudio time format tmsf')  // "00:00"
      return

endclass
